section.begin
   Name = ShowMenu
   Code : struct.begin
      [*] = ;const bupdate = False;
      [*] = ;const currentstatename = 'ShowMenu';
      [*] = ;var elmname, showstate, eventstate : String;
      [*] = ;_misc_GetGUIShowEventStateNames(currentstatename, elmname, showstate, eventstate);
      [*] = ;
      [*] = ;dbgstatename := showstate;
      [*] = ;
      [*] = ;var cTextMenuHeader : String = 'gui|menu.gamemenu';
      [*] = ;
      [*] = ;const cmargin = 6;
      [*] = ;const cmargin1 = cmargin;
      [*] = ;const cmargin2 = cmargin*2;
      [*] = ;const cmargin3 = cmargin*3;
      [*] = ;const cmargin4 = cmargin*4;
      [*] = ;const cmargin5 = cmargin*5;
      [*] = ;const cmargin6 = cmargin*6;
      [*] = ;const cmargin7 = cmargin*7;
      [*] = ;const cmargin8 = cmargin*8;
      [*] = ;const cTextWrapWidth = 300;
      [*] = ;const cMinWidth = 200;
      [*] = ;const cMinHeight = 140;
      [*] = ;
      [*] = ;// variables
      [*] = ;var elmHnd : Integer;
      [*] = ;var nul, text : String;
      [*] = ;var w, h : Integer;
      [*] = ;var maxwidth : Integer = cMinWidth;
      [*] = ;var maxheight : Integer = cMinHeight;
      [*] = ;var color, btncolor, shcolor : TColor;
      [*] = ;_gui_SetupTColorInteger(255, 238, 223, 168, 1, shcolor);
      [*] = ;_gui_SetupTColorInteger(48, 32, 32, 255, 1, color);
      [*] = ;_gui_SetupTColorInteger(255, 220, 170, 255, 0.9, btncolor);
      [*] = ;
      [*] = ;function ShowText(const elmName : String; elmHnd, parentHnd : Integer; var text : String; font, margin : Integer) : Integer;
      [*] = ;begin
      [*] = ;   var stext : String = GetGUIWrappedTextByFont(gUIConst.font[font], text, cTextWrapWidth);
      [*] = ;   GetGUIElementFontTextRect(gUIConst.font[font], stext, w, h);
      [*] = ;   maxwidth := Max(maxwidth, w);
      [*] = ;   Result := _gui_CreateText(elmName, parentHnd, stext, gc_halParentMiddle, gc_valParentTop, 0, _gui_GetBottomPos(elmHnd)+margin, 0, 0, gc_halLeft, gc_valTop, font, color, bupdate);
      [*] = ;end;
      [*] = ;function ShowButton(const elmName : String; elmHnd, parentHnd : Integer; btnMaterial : String; var text : String; margin, tag : Integer; bEnabled : Boolean) : Integer;
      [*] = ;begin
      [*] = ;   Result := _gui_CreateButton(elmName, parentHnd, btnMaterial, gc_halParentMiddle, gc_valParentTop, 0, _gui_GetBottomPos(elmHnd)+margin, 0, 0, eventstate, nul, tag, bupdate);
      [*] = ;   SetGUIElementEnabled(Result, bEnabled);
      [*] = ;   _gui_CreateText('txtbtn', Result, text, gc_halParentMiddle, gc_valParentMiddle, 0, 0, 0, 0, gc_halLeft, gc_valMiddle, gc_font_serif_15, btncolor, bupdate);
      [*] = ;end;
      [*] = ;
      [*] = ;var dpiscale : Float = _gui_GetAbsScaleByDPI(0, 0);
      [*] = ;var elmParent : Integer = _gui_CreateParent(elmname, 0, gc_halLeft, gc_valTop, 0, 0, round(GetViewerWidth/dpiscale), round(GetViewerHeight/dpiscale), bupdate);
      [*] = ;_gui_AbsScaleByDPI(elmParent);
      [*] = ;var elmMask : Integer = _gui_CreateImageActive('blackmask', elmParent, gc_gui_material_black, gc_halParentLeft, gc_valParentTop, 0, 0, GetViewerWidth, GetViewerHeight, 0, '', '', bupdate);
      [*] = ;var elmBackgroundParent : Integer = _gui_CreateParent('backgroundparent', elmParent, gc_halLeft, gc_valTop, 0, 0, round(GetViewerWidth/dpiscale), round(GetViewerHeight/dpiscale), bupdate);
      [*] = ;var elmMain : Integer = _gui_CreateParent('main', elmParent, gc_halLeft, gc_valTop, 0, 0, round(GetViewerWidth/dpiscale), round(GetViewerHeight/dpiscale), bupdate);
      [*] = ;SetGUIElementUserBlend(elmMask, 0.325);
      [*] = ;SetGUIElementPressState(elmParent, eventstate);
      [*] = ;
      [*] = ;var cTextContinue : String = GetLocaleTableListItemByID('gui', 'menu.btn.continue');
      [*] = ;var cTextSettings : String = GetLocaleTableListItemByID('gui', 'menu.btn.settings');
      [*] = ;var cTextSaveGame : String = GetLocaleTableListItemByID('gui', 'menu.btn.savegame');
      [*] = ;var cTextLoadGame : String = GetLocaleTableListItemByID('gui', 'menu.btn.loadgame');
      [*] = ;var cTextSaveReplay : String = GetLocaleTableListItemByID('misc', 'loadgame.savereplay');
      [*] = ;var cTextExitToMainMenu : String = GetLocaleTableListItemByID('gui', 'menu.btn.exittomainmenu');
      [*] = ;
      [*] = ;var cTextSurrender, cTextStatistics : String;
      [*] = ;_misc_GetNewTextLocale('menu.btn.surrender', cTextSurrender);
      [*] = ;_misc_GetNewTextLocale('menu.btn.statistics', cTextStatistics);
      [*] = ;
      [*] = ;const cTagContinue = 101;
      [*] = ;const cTagSettings = 102;
      [*] = ;const cTagSaveGame = 103;
      [*] = ;const cTagLoadGame = 104;
      [*] = ;const cTagExitToMainMenu = 105;
      [*] = ;const cTagExitToMainMenuApprove = 106;
      [*] = ;const cTagSurrender = 107;
      [*] = ;const cTagSurrenderApprove = 108;
      [*] = ;const cTagStatistics = 109;
      [*] = ;const cTagSaveReplay = 110;
      [*] = ;
      [*] = ;var plInd : Integer = GetPlayerIndexByHandle(GetPlayerHandleInterfaceIO);
      [*] = ;
      [*] = ;const cSmallOffset = 10;
      [*] = ;
      [*] = ;elmHnd := _gui_CreateTextShadowed('thead', elmMain, cTextMenuHeader, gc_halParentMiddle, gc_valParentTop, 0, round(cmargin4*dpiscale), 0, 0, gc_halMiddle, gc_valMiddle, gc_font_serif_21, color, 1, 2, shcolor, bupdate);
      [*] = ;const cbtnmat = 'btn.large';
      [*] = ;elmHnd := ShowButton('bcontinue', elmHnd, elmMain, 'btn.green', cTextContinue, cmargin2, cTagContinue, True);//MGraphics
      [*] = ;elmHnd := ShowButton('bsettings', elmHnd, elmMain, cbtnmat, cTextSettings, cmargin2+25, cTagSettings, True);
      [*] = ;elmHnd := ShowButton('bsavereplay', elmHnd, elmMain, cbtnmat, cTextSaveReplay, cmargin2+cSmallOffset, cTagSaveReplay, (not _net_IsReplay) and (not gbool_gui_querywindow));
      [*] = ;elmHnd := ShowButton('bsavegame', elmHnd, elmMain, cbtnmat, cTextSaveGame, cmargin2, cTagSaveGame, (not _net_IsReplay) and (not gbool_gui_querywindow) and (gPlayer[plind].victorystate=gc_player_victorystate_none) and (not _net_IsOnline));
      [*] = ;elmHnd := ShowButton('bloadgame', elmHnd, elmMain, cbtnmat, cTextLoadGame, cmargin2, cTagLoadGame, (not _net_IsOnline));
      [*] = ;if (not _net_IsReplay) and (gPlayer[plInd].victorystate=gc_player_victorystate_none) then
      [*] = ;elmHnd := ShowButton('bsurrender', elmHnd, elmMain, 'btn.red', cTextSurrender, cmargin2+cSmallOffset, cTagSurrender, True)//MGraphics
      [*] = ;else
      [*] = ;elmHnd := ShowButton('bstatistics', elmHnd, elmMain, cbtnmat, cTextStatistics, cmargin2+cSmallOffset, cTagStatistics, True);
      [*] = ;var tag : Integer = _misc_SwitchInt(cTagExitToMainMenuApprove, cTagExitToMainMenu, (gProfile.bNewMapOnMainMenu));
      [*] = ;elmHnd := ShowButton('bexittomainmenu', elmHnd, elmMain, 'btn.red', cTextExitToMainMenu, cmargin2, tag, True);//MGraphics
      [*] = ;
      [*] = ;// background
      [*] = ;maxheight := Max(maxheight, _gui_GetBottomPos(elmHnd)+cmargin7);
      [*] = ;var elmBackground : Integer = _gui_CreatePaperWindow('background', elmBackgroundParent, gc_halParentMiddle, gc_valParentMiddle, 0, 0, maxwidth+cmargin8*2, maxheight, 1, False, bupdate);
      [*] = ;SetGUIElementPositionY(elmBackgroundParent, 0);
      [*] = ;SetGUIElementPositionY(elmMain, round((GetViewerHeight div 2) - _gui_GetBottomPos(elmBackground)/2*dpiscale));
      [*] = ;
      [*] = ;//elmHnd := _gui_CreateButton('bclose', elmBackground, 'btn.close', gc_halParentRightWidth, gc_valParentTop, -5, 7, 0, 0, eventstate, nul, gc_gui_event_tagClose, bupdate);
      [*] = ;
      [*] = ;IntRegister2 := elmParent;
      [*] = ;
      [*] = ;gint_gui_changeresolutionstage := 4;
      [*] = ;
      [*] = ;if (GetGUIMiniMapVisible) then
      [*] = ;_misc_SetMinimapVisible(False);
   struct.end
section.end

