section.begin
   Name = ShowResourcePanel
   Code : struct.begin
      [*] = ;if (GetPlayerHandleInterfaceIO=0) then
      [*] = ;exit;
      [*] = ;
      [*] = ;const currentstatename = 'ShowResourcePanel';
      [*] = ;var elmname, showstate, eventstate : String;
      [*] = ;_misc_GetGUIShowEventStateNames(currentstatename, elmname, showstate, eventstate);
      [*] = ;
      [*] = ;const cElmMenuName = 'menu';
      [*] = ;
      [*] = ;const cTagMenuShow = 100;
      [*] = ;const cTagMenuClose = 101;
      [*] = ;const cTagIdlePeasants = 110;
      [*] = ;const cTagIdleMines = 111;
      [*] = ;const cTagShowHideObjectives = 112;
      [*] = ;
      [*] = ;//const cButtonOffsetX = -362;
      [*] = ;//const cButtonOffsetY = 1;
      [*] = ;const cButtonOffsetX = 11;
      [*] = ;const cButtonOffsetY = 40;
      [*] = ;
      [*] = ;const cResourceSizeXMin = 0;
      [*] = ;const cResourceOffY = -7;
      [*] = ;const cPopulationOffsetX = 64;
      [*] = ;
      [*] = ;var cTextHintFood : String = gUIConst.fontstyle[gc_font_sans_13]+GetLocaleTableListItemByID('gui', 'resourcepanel.food.hint');
      [*] = ;var cTextHintWood : String = gUIConst.fontstyle[gc_font_sans_13]+GetLocaleTableListItemByID('gui', 'resourcepanel.wood.hint')+gc_gui_breakline+gc_gui_breakspace4+GetLocaleTableListItemByID('gui', 'resourcepanel.wood.hint.add');
      [*] = ;var cTextHintStone : String = gUIConst.fontstyle[gc_font_sans_13]+GetLocaleTableListItemByID('gui', 'resourcepanel.stone.hint')+gc_gui_breakline+gc_gui_breakspace4+GetLocaleTableListItemByID('gui', 'resourcepanel.stone.hint.add');
      [*] = ;var cTextHintGold : String = gUIConst.fontstyle[gc_font_sans_13]+GetLocaleTableListItemByID('gui', 'resourcepanel.gold.hint')+gc_gui_breakline+gc_gui_breakspace4+GetLocaleTableListItemByID('gui', 'resourcepanel.gold.hint.add');
      [*] = ;var cTextHintIron : String = gUIConst.fontstyle[gc_font_sans_13]+GetLocaleTableListItemByID('gui', 'resourcepanel.iron.hint')+gc_gui_breakline+gc_gui_breakspace4+GetLocaleTableListItemByID('gui', 'resourcepanel.iron.hint.add');
      [*] = ;var cTextHintCoal : String = gUIConst.fontstyle[gc_font_sans_13]+GetLocaleTableListItemByID('gui', 'resourcepanel.coal.hint')+gc_gui_breakline+gc_gui_breakspace4+GetLocaleTableListItemByID('gui', 'resourcepanel.coal.hint.add');
      [*] = ;var cTextHintFarm : String = GetLocaleTableListItemByID('gui', 'resourcepanel.populationlimit');
      [*] = ;var cTextIdlePeasants : String = GetLocaleTableListItemByID('gui', 'control.btn.idlepeasants');
      [*] = ;var cTextIdleMines : String = GetLocaleTableListItemByID('gui', 'control.btn.idlemines');
      [*] = ;var cTextLowFood : String = GetLocaleTableListItemByID('gui', 'resourcepanel.lowfood');
      [*] = ;var cTextLotOfResources : String = GetLocaleTableListItemByID('gui', 'resourcepanel.lotofresources');
      [*] = ;
      [*] = ;var cTextShowObjectivesDisabled : String = GetLocaleTableListItemByID('misc', 'resourcepanel.showobjectivesdisabled');
      [*] = ;var cTextHideObjectives : String = GetLocaleTableListItemByID('misc', 'resourcepanel.hideobjectives');
      [*] = ;var cTextShowObjectives : String = GetLocaleTableListItemByID('misc', 'resourcepanel.showobjectives');
      [*] = ;
      [*] = ;var cResourceSizeX : Integer = 162; // 122
      [*] = ;//cResourceSizeX := Max(cResourceSizeX, cResourceSizeXMin);
      [*] = ;var dpiscale : Float = _gui_GetAbsScaleByDPI(0, 0);
      [*] = ;var basedpiscale : Float = dpiscale;
      [*] = ;if (GetViewerWidth<2520) then
      [*] = ;dpiscale := 1;
      [*] = ;var minwidth : Integer = 1440;
      [*] = ;const cminwidth = 1280;
      [*] = ;if ((GetViewerWidth)<1260) then
      [*] = ;dpiscale := GetViewerWidth/1260;
      [*] = ;var elmParent : Integer = _gui_CreateParent(elmname, 0, gc_halParentLeft, gc_valParentTop, 0, 0, round(GetViewerWidth/dpiscale), GetGUITextureHeight('resourcepanel.background'), True);
      [*] = ;_gui_AbsScaleByDPI(elmParent);
      [*] = ;_gui_SetAbsScale(elmParent, dpiscale);
      [*] = ;SetGUIElementVisible(elmParent, (gInterface.gamemode<>gc_gamemode_mainmenu));
      [*] = ;var xoff : Integer;
      [*] = ;if ((GetViewerWidth/basedpiscale)<cminwidth) then
      [*] = ;xoff := round(-45*dpiscale)
      [*] = ;else
      [*] = ;if ((GetViewerWidth/basedpiscale)<1440) then
      [*] = ;xoff := round(-100);
      [*] = ;var elm : Integer = _gui_CreateImageActive('resbackground', elmParent, 'resourcepanel.background', gc_halParentMiddle, gc_valParentTop, xoff, cResourceOffY, 0, 0, 0, '', '', True);
      [*] = ;
      [*] = ;var plHnd : Integer = GetPlayerHandleInterfaceIO;
      [*] = ;var plInd : Integer = GetPlayerIndexByHandle(plHnd);
      [*] = ;var color, shcolor : TColor;
      [*] = ;_gui_ConvertHexToTColor(gc_font_hex_color_white, color);
      [*] = ;color.r := 0.921875*0.94;
      [*] = ;color.g := 0.75*0.98;
      [*] = ;color.b := 0.59375*0.98;
      [*] = ;_gui_ConvertHexToTColor(gc_font_hex_color_black, shcolor);
      [*] = ;
      [*] = ;var i : Integer;
      [*] = ;for i:=1 to gc_ResCount-1 do
      [*] = ;begin
      [*] = ;   var x : Integer = (cResourceSizeX)*((i mod (gc_ResCount))-1)-((gc_ResCount div 2)*cResourceSizeX)+84+5;
      [*] = ;   if ((gc_ResCount mod 2)<>0) then
      [*] = ;   x := x+(cResourceSizeX div 2);
      [*] = ;   const cSideOffsetX = -10;
      [*] = ;   if (i<4) then
      [*] = ;   x := x+(cSideOffsetX div 2)
      [*] = ;   else
      [*] = ;   x := x+cSideOffsetX+4;
      [*] = ;
      [*] = ;   var ind : Integer = i; // swap wood and food visualization to correspond c1
      [*] = ;   if i=1 then ind := 2
      [*] = ;   else
      [*] = ;   if i=2 then ind := 1;
      [*] = ;
      [*] = ;   var hint : String;
      [*] = ;   case ind of
      [*] = ;      gc_resource_type_food : hint := cTextHintFood;
      [*] = ;      gc_resource_type_wood : hint := cTextHintWood;
      [*] = ;      gc_resource_type_stone : hint := cTextHintStone;
      [*] = ;      gc_resource_type_gold : hint := cTextHintGold;
      [*] = ;      gc_resource_type_iron : hint := cTextHintIron;
      [*] = ;      gc_resource_type_coal : hint := cTextHintCoal;
      [*] = ;   end;
      [*] = ;   var text : String = IntToStr(gPlayer[plInd].res[ind]);
      [*] = ;   if gPlayer[plInd].res[ind]>99999999 then
      [*] = ;   text := cTextLotOfResources;
      [*] = ;   var income : Integer = gPlayer[plInd].counter.workersonres[ind];
      [*] = ;   if (ind>=gc_resource_type_gold) then
      [*] = ;   begin
      [*] = ;      var rawconsume : Float = floor((gPlayer[plind].counter.resconsume[ind]*32/100)/250);
      [*] = ;      income := floor(income-rawconsume);
      [*] = ;   end;
      [*] = ;   if (income>0) then
      [*] = ;   text := text+gc_font_color_darkgrey+'  ('+IntToStr(income)+')'
      [*] = ;   else
      [*] = ;   if (income<0) then
      [*] = ;   text := text+ gc_font_color_red+'  ('+IntToStr(income)+')';
      [*] = ;
      [*] = ;   _gui_CreateTextShadowed('resource'+IntToStr(ind), elmParent, text, gc_halParentMiddle, gc_valParentTop, x+xoff, cResourceOffY-4, cResourceSizeX, GetGUIElementHeight(elmParent), gc_halLeft, gc_valMiddle, gc_font_serif_13, color, 1, 1, shcolor, True);
      [*] = ;   _gui_CreateImageActive('resourcehint'+IntToStr(ind), elmParent, gc_gui_material_blank, gc_halParentMiddle, gc_valParentMiddle, x-60, cResourceOffY-10, cResourceSizeX-10, GetGUIElementHeight(elmParent), 0, '', hint, True);
      [*] = ;end;
      [*] = ;
      [*] = ;var text : String;
      [*] = ;var textcolor : String;
      [*] = ;_gui_ConvertTColorToTextColor(color, textcolor);
      [*] = ;
      [*] = ;var bpopulationlimit : Boolean = (gPlayer[plInd].counter.farmused>=gPlayer[plInd].farm);
      [*] = ;var elmPopulationHnd : Integer = _gui_CreateImageActive('population', elmParent, gc_gui_material_blank, gc_halParentLeft, gc_valParentTop, 0, 5, 142, GetGUIElementHeight(elmParent), 0, '', cTextHintFarm, True);
      [*] = ;var elmHnd : Integer = _gui_CreateImageActive('icon', elmPopulationHnd, 'icons.nofarm', gc_halParentLeft, gc_valParentTop, 0, 3, 0, 0, 0, '', cTextHintFarm, True);
      [*] = ;if (bpopulationlimit) and (not GetGUIElementFadeStarted(elmHnd)) then
      [*] = ;begin
      [*] = ;   SetGUIElementFadeStart(elmHnd, false);
      [*] = ;   SetGUIElementFadeAutoDestroy(elmHnd, false);
      [*] = ;   SetGUIElementFadeInEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFadeOutEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFreezeEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFadeRecursiveEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFadingTimes(elmHnd, 0.85, 0);
      [*] = ;   SetGUIElementFadeStart(elmHnd, true);
      [*] = ;end
      [*] = ;else
      [*] = ;if (not bpopulationlimit) and (GetGUIElementFadeStarted(elmHnd)) then
      [*] = ;SetGUIElementFadeStart(elmHnd, false);
      [*] = ;
      [*] = ;if (bpopulationlimit) then
      [*] = ;begin
      [*] = ;   text := GetLocaleTableListItemByID('misc', 'resourcepanel.farmsnotenough');
      [*] = ;   text := StrReplace(text, '%farmused%', gc_font_color_red+IntToStr(gPlayer[plInd].counter.farmused)+textcolor);
      [*] = ;end
      [*] = ;else
      [*] = ;begin
      [*] = ;   text := GetLocaleTableListItemByID('misc', 'resourcepanel.farms');
      [*] = ;   text := StrReplace(text, '%farmused%', IntToStr(gPlayer[plInd].counter.farmused));
      [*] = ;end;
      [*] = ;text := StrReplace(text, '%farmexist%', IntToStr(gPlayer[plInd].farm));
      [*] = ;_gui_CreateTextShadowed('_txt_population', elmPopulationHnd, text, gc_halParentLeft, gc_valParentTop, cPopulationOffsetX, 0, 0, GetGUIElementHeight(elmParent), gc_halLeft, gc_valMiddle, gc_font_sans_12, color, 1, 1, shcolor, True);
      [*] = ;
      [*] = ;var bObjectivesExists : Boolean;
      [*] = ;if (gScenario.bactive) then
      [*] = ;begin
      [*] = ;   var i : Integer;
      [*] = ;   for i:=0 to gc_scenario_maxobjectives-1 do
      [*] = ;   if (gScenario.objectives[i].bvisible) then
      [*] = ;   begin
      [*] = ;      bObjectivesExists := True;
      [*] = ;      break;
      [*] = ;   end;
      [*] = ;end;
      [*] = ;
      [*] = ;var posY : Integer;
      [*] = ;if (bObjectivesExists) then
      [*] = ;posY := 50;
      [*] = ;var idlecount : Integer = gPlayer[plInd].counter.idlepeasants;
      [*] = ;text := IntToStr(idlecount);
      [*] = ;var elmIdlePeasantsHnd : Integer = _gui_CreateImage('_img_idlepeasants', elmParent, gc_hud_icons_control+'idlepeasants', gc_halParentLeft, gc_valParentTop, 3, 64+posY, 0, 0, 0, True);
      [*] = ;var hint : String = cTextIdlePeasants;
      [*] = ;_gui_CreateButton('_btn_idlepeasants', elmIdlePeasantsHnd, gc_gui_material_blank, gc_halParentLeft, gc_valParentTop, 0, 0, GetGUIElementWidth(elmIdlePeasantsHnd), GetGUIElementHeight(elmIdlePeasantsHnd), eventstate, hint, cTagIdlePeasants, True);
      [*] = ;elmHnd := _gui_CreateText('_txt_idlepeasants', elmIdlePeasantsHnd, text, gc_halParentLeft, gc_valParentTop, 3, 0, GetGUIElementWidth(elmIdlePeasantsHnd), GetGUIElementHeight(elmIdlePeasantsHnd), gc_halLeft, gc_valTop, gc_font_serif_14, color, True);
      [*] = ;SetGUIElementVisible(elmHnd, ((idlecount>0)));
      [*] = ;if (idlecount>0) then
      [*] = ;SetGUIElementUserBlend(elmIdlePeasantsHnd, 1)
      [*] = ;else
      [*] = ;SetGUIElementUserBlend(elmIdlePeasantsHnd, 0.4);
      [*] = ;//SetGUIElementVisible(elmIdlePeasantsHnd, (idlecount>0));
      [*] = ;
      [*] = ;idlecount := gPlayer[plInd].counter.idlemines;
      [*] = ;text := IntToStr(idlecount);
      [*] = ;var elmIdleMinesHnd : Integer = _gui_CreateImage('_img_idlemines', elmParent, gc_hud_icons_control+'idlemines', gc_halParentLeft, gc_valParentTop, 3, 64+posY+50, 0, 0, 0, True);
      [*] = ;hint := cTextIdleMines;
      [*] = ;_gui_CreateButton('_btn_idlemines', elmIdleMinesHnd, gc_gui_material_blank, gc_halParentLeft, gc_valParentTop, 0, 0, GetGUIElementWidth(elmIdlePeasantsHnd), GetGUIElementHeight(elmIdlePeasantsHnd), eventstate, hint, cTagIdleMines, True);
      [*] = ;elmHnd := _gui_CreateText('_txt_idlemines', elmIdleMinesHnd, text, gc_halParentLeft, gc_valParentTop, 3, 0, GetGUIElementWidth(elmIdlePeasantsHnd), GetGUIElementHeight(elmIdlePeasantsHnd), gc_halLeft, gc_valTop, gc_font_serif_14, color, True);
      [*] = ;SetGUIElementVisible(elmHnd, ((idlecount>0)));
      [*] = ;if (idlecount>0) then
      [*] = ;SetGUIElementUserBlend(elmIdleMinesHnd, 1)
      [*] = ;else
      [*] = ;SetGUIElementUserBlend(elmIdleMinesHnd, 0.5);
      [*] = ;//SetGUIElementVisible(elmIdleMinesHnd, (idlecount>0));
      [*] = ;
      [*] = ;var bWasVisible, bInFade : Boolean;
      [*] = ;var bNeedVisible : Boolean = bObjectivesExists and (not gInterface.bhideobjectives);
      [*] = ;var tmp : Integer = GetGUIElementIndexByNameParent('objs', elmParent);
      [*] = ;if (tmp<>0) then
      [*] = ;tmp := GetGUIElementIndexByNameParent('obj_fade', tmp);
      [*] = ;if (tmp<>0) then
      [*] = ;begin
      [*] = ;   bWasVisible := GetGUIElementVisible(tmp);
      [*] = ;   bInFade := GetGUIElementFadeStarted(tmp);
      [*] = ;end;
      [*] = ;if (bObjectivesExists) and (not bNeedVisible) and (gInterface.showobjectivestimer>0) and (not gbool_gui_querywindow) then
      [*] = ;begin
      [*] = ;   if ((gInterface.showobjectivestimer+gc_gui_objectivesshowtime)>GetCurrentTime) then
      [*] = ;   bNeedVisible := True;
      [*] = ;end;
      [*] = ;
      [*] = ;var bPaper : Boolean = False; // for design tests
      [*] = ;var cpadding : Integer;
      [*] = ;var elmObjectivesBackground : Integer;
      [*] = ;if (bPaper) then
      [*] = ;cpadding := 38
      [*] = ;else
      [*] = ;cpadding := 8;
      [*] = ;var elmObjectives : Integer = _gui_CreateParent('objs', elmParent, gc_halParentLeft, gc_valParentTop, 54+5+cpadding-8, 66+cpadding-8, 0, 0, True);
      [*] = ;if (bPaper) then
      [*] = ;elmObjectivesBackground := _gui_CreateParent('bcg', elmObjectives, gc_halParentLeft, gc_valParentTop, 0, 0, 0, 0, True);
      [*] = ;//SetGUIElementUserBlend(elmObjectives, 1);
      [*] = ;if (gScenario.bactive) then
      [*] = ;begin
      [*] = ;   var listid : TIntegerList;
      [*] = ;   var listgametime : TIntegerList;
      [*] = ;   var material : String;
      [*] = ;   if (not bObjectivesExists) then
      [*] = ;   begin
      [*] = ;      material := gc_hud_icons_control+'showobjectives';
      [*] = ;      hint := cTextShowObjectivesDisabled;
      [*] = ;   end
      [*] = ;   else
      [*] = ;   if (not gInterface.bhideobjectives) then
      [*] = ;   begin
      [*] = ;      material := gc_hud_icons_control+'hideobjectives';
      [*] = ;      hint := cTextHideObjectives;
      [*] = ;   end
      [*] = ;   else
      [*] = ;   begin
      [*] = ;      material := gc_hud_icons_control+'showobjectives';
      [*] = ;      hint := cTextShowObjectives;
      [*] = ;   end;
      [*] = ;   var elmSwitchShowObjectivesHnd : Integer = _gui_CreateImage('_img_switchobjectives', elmParent, material, gc_halParentLeft, gc_valParentTop, 3, 64{+50+50}, 0, 0, 0, True);
      [*] = ;   var elmFadeHnd : Integer = _gui_CreateImage('obj_fade', elmObjectives, gc_gui_material_blank, gc_halParentLeft, gc_valParentTop, 0, 0, 0, 0, 0, True);
      [*] = ;   if (gInterface.bupdateobjectivestext) then
      [*] = ;   begin
      [*] = ;      RemoveGUIChildren(elmFadeHnd);
      [*] = ;      gInterface.bupdateobjectivestext := False;
      [*] = ;   end;
      [*] = ;
      [*] = ;   _gui_CreateButton('swobj', elmSwitchShowObjectivesHnd, gc_gui_material_blank, gc_halParentLeft, gc_valParentTop, 0, 0, GetGUIElementWidth(elmIdlePeasantsHnd), GetGUIElementHeight(elmIdlePeasantsHnd), eventstate, hint, cTagShowHideObjectives, True);
      [*] = ;   SetGUIElementVisible(elmSwitchShowObjectivesHnd, True);
      [*] = ;
      [*] = ;   var i : Integer;
      [*] = ;   for i:=0 to gc_scenario_maxobjectives-1 do
      [*] = ;   if (gScenario.objectives[i].bvisible) then
      [*] = ;   begin
      [*] = ;      listid.Add(i);
      [*] = ;      listgametime.Add(Round(gScenario.objectives[i].gametime));
      [*] = ;   end;
      [*] = ;   if (listgametime.GetCount>0) and (listid.GetCount>0) then
      [*] = ;   begin
      [*] = ;      _misc_SortIntegerLists2D(listgametime, listid, False);
      [*] = ;   end;
      [*] = ;
      [*] = ;   var elmHnd : Integer = _gui_CreateImage('obj_mask', elmFadeHnd, gc_gui_material_black, gc_halParentLeft, gc_valParentTop, -cpadding, -cpadding, 0, 0, 0, True);
      [*] = ;   if (bPaper) then
      [*] = ;   SetGUIElementUserBlend(elmHnd, 0.0)
      [*] = ;   else
      [*] = ;   SetGUIElementUserBlend(elmHnd, 0.5);
      [*] = ;   var posY, maxw : Integer;
      [*] = ;   for i:=0 to listid.GetCount-1 do
      [*] = ;   begin
      [*] = ;      var ind : Integer = listid.Get(i);
      [*] = ;      const font = gc_font_serif_12;
      [*] = ;      var sfont : String = gUIConst.font[font];
      [*] = ;      var text : String = GetLocaleTableListItemByID(gScenario.objectives[ind].langtable, gScenario.objectives[ind].langkey);
      [*] = ;      if (text<>'') then
      [*] = ;      begin
      [*] = ;         var tw : Integer;
      [*] = ;         var th : Integer;
      [*] = ;         text := #149+' '+text;
      [*] = ;         if (i<(listid.GetCount-1)) then
      [*] = ;         text := text+gc_gui_breakspace2;
      [*] = ;         text := GetGUIWrappedTextFormatByFont(sfont, text, 500);
      [*] = ;         GetGUIElementFontTextFormatRect(sfont, text, tw, th);
      [*] = ;         maxw := Max(maxw, tw);
      [*] = ;         if gScenario.objectives[ind].bdone then
      [*] = ;         _gui_ConvertHexToTColor(gc_font_hex_color_darkgrey, color)
      [*] = ;         else
      [*] = ;         _gui_ConvertHexToTColor(gc_font_hex_color_white, color);
      [*] = ;         color.r := color.r*0.97;
      [*] = ;         color.g := color.g*0.97;
      [*] = ;         color.b := color.b*0.97;
      [*] = ;
      [*] = ;         if (bPaper) then
      [*] = ;         begin
      [*] = ;            color.r := 0.25;
      [*] = ;            color.g := 0.0;
      [*] = ;            color.b := 0.0;
      [*] = ;         end;
      [*] = ;         text := StrReplace(text, '%hotkey|unit|standground%', '"S"');
      [*] = ;         text := StrReplace(text, '%hotkey|unit|nostandground%', '"C"');
      [*] = ;         text := StrReplace(text, '%hotkey|unit|attack%', '"A"');
      [*] = ;         _gui_CreateText('_txt_obj'+IntToStr(i), elmFadeHnd, text, gc_halParentLeft, gc_valParentTop, 0, posY, tw, th, gc_halLeft, gc_valTop, font, color, True);
      [*] = ;         posY := posY+th;
      [*] = ;      end;
      [*] = ;   end;
      [*] = ;   SetGUIElementWidth(elmHnd, maxw+cpadding*2);
      [*] = ;   SetGUIElementHeight(elmHnd, posY+cpadding*2);
      [*] = ;   if (bPaper) then
      [*] = ;   _gui_CreatePaperWindow('objs', elmObjectivesBackground, gc_halParentLeft, gc_valParentTop, -cpadding, -cpadding, maxw+cpadding*2, posY+cpadding*2, 1, False, True);
      [*] = ;   if (maxw<=0) then
      [*] = ;   SetGUIElementVisible(elmFadeHnd, False)
      [*] = ;   else
      [*] = ;   if (bWasVisible) and (not bNeedVisible) then
      [*] = ;   begin
      [*] = ;      if (not bInFade) then
      [*] = ;      _gui_FadeElementExt(elmFadeHnd, 0.5, 0, False, True);
      [*] = ;   end
      [*] = ;   else
      [*] = ;   if (not bWasVisible) and (bNeedVisible) then
      [*] = ;   begin
      [*] = ;      if (not bInFade) then
      [*] = ;      _gui_FadeElementExt(elmFadeHnd, 0.5, 0, True, False);
      [*] = ;   end
      [*] = ;   else
      [*] = ;   if (not bWasVisible) and (not bNeedVisible) then
      [*] = ;   SetGUIElementVisible(elmFadeHnd, False)
      [*] = ;   else
      [*] = ;   SetGUIElementVisible(elmFadeHnd, True);
      [*] = ;end
      [*] = ;else
      [*] = ;RemoveGUIChildren(elmObjectives);
      [*] = ;
      [*] = ;{var blowfood : Boolean = (gPlayer[plind].res[gc_resource_type_food]<500);
      [*] = ;hint := cTextLowFood;
      [*] = ;elmHnd := _gui_CreateImageActive('_img_lowfood', elmParent, 'icons.res.'+IntToStr(gc_resource_type_food), gc_halParentLeft, gc_valParentTop, 3, 64+50*2, 0, 0, 0, '', hint, True);
      [*] = ;//SetGUIElementVisible(elmHnd, blowfood);
      [*] = ;if (blowfood) and (not GetGUIElementFadeStarted(elmHnd)) then
      [*] = ;begin
      [*] = ;   SetGUIElementFadeStart(elmHnd, false);
      [*] = ;   SetGUIElementFadeAutoDestroy(elmHnd, false);
      [*] = ;   SetGUIElementFadeInEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFadeOutEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFreezeEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFadeRecursiveEnabled(elmHnd, true);
      [*] = ;   SetGUIElementFadingTimes(elmHnd, 0.85, 0);
      [*] = ;   SetGUIElementFadeStart(elmHnd, true);
      [*] = ;end
      [*] = ;else
      [*] = ;if (not blowfood) and (GetGUIElementFadeStarted(elmHnd)) then
      [*] = ;SetGUIElementFadeStart(elmHnd, false);
      [*] = ;SetGUIElementVisible(elmHnd, blowfood);}
      [*] = ;
      [*] = ;var tag : Integer;
      [*] = ;var elmMenuParent : Integer = GetGUIElementIndexByNameParent(cElmMenuName, _gui_GetTop);
      [*] = ;if (elmMenuParent=0) or (not GetGUIElementVisible(elmMenuParent)) then
      [*] = ;tag := gc_gui_event_tagShow
      [*] = ;else
      [*] = ;tag := gc_gui_event_tagClose;
      [*] = ;var nul : String;
      [*] = ;var elmBtnMenu : Integer = _gui_CreateButton('btnmenu', elmParent, 'btn.menu', gc_halParentRightWidth, gc_valParentTop, -1, 1, 0, 0, eventstate, nul, tag, True);
      [*] = ;var cTextMenu : String = GetLocaleTableListItemByID('gui', 'menu.gamemenu'){+' (F10)'};
      [*] = ;_gui_ConvertHexToTColor(gc_font_hex_color_lightgrey, color);
   struct.end
section.end

