section.begin
   Name = ShowMainMenu
   Code : struct.begin
      [*] = ;const bupdate = True;
      [*] = ;const currentstatename = 'ShowMainMenu';
      [*] = ;var elmname, showstate, eventstate : String;
      [*] = ;_misc_GetGUIShowEventStateNames(currentstatename, elmname, showstate, eventstate);
      [*] = ;
      [*] = ;var ui : TUI;
      [*] = ;ui.SetContainerMaxWidthType(0);
      [*] = ;ui.SetDebug(True);
      [*] = ;
      [*] = ;var nul : String;
      [*] = ;var btncolor : TColor;
      [*] = ;_gui_SetupTColorInteger(255, 220, 170, 255, 0.9, btncolor);
      [*] = ;function ShowButton(const elmName : String; elmHnd, parentHnd : Integer; btnMaterial : String; var text : String; margin, tag : Integer; bEnabled : Boolean) : Integer;
      [*] = ;begin
      [*] = ;   _gui_HighlightTextHotkey(text, eventstate, elmName, text, False);
      [*] = ;   Result := _gui_CreateButton(elmName, parentHnd, btnMaterial, gc_halParentMiddle, gc_valParentTop, 0, _gui_GetBottomPos(elmHnd)+margin, 0, 0, eventstate, nul, tag, bupdate);
      [*] = ;   SetGUIElementEnabled(Result, bEnabled);
      [*] = ;   _gui_CreateText('txtbtn', Result, text, gc_halParentMiddle, gc_valParentMiddle, 0, 0, 0, 0, gc_halLeft, gc_valMiddle, gc_font_serif_15, btncolor, bupdate);
      [*] = ;end;
      [*] = ;
      [*] = ;const cmargin = 1; //MGraphics
      [*] = ;const cmargin1 = cmargin;
      [*] = ;const cmargin2 = cmargin*2;
      [*] = ;
      [*] = ;const cBtnOffset = 64;
      [*] = ;const cTagProfile = 100;
      [*] = ;const cTagCampaign = 101;
      [*] = ;const cTagRandomMap = 102;
      [*] = ;const cTagMultiplayer = 103;
      [*] = ;const cTagSettings = 104;
      [*] = ;const cTagLoadGame = 105;
      [*] = ;const cTagLoadReplay = 106;
      [*] = ;const cTagEditor = 107;
      [*] = ;const cTagExit = 108;
      [*] = ;
      [*] = ;var dpiscale : Float = _gui_GetAbsScaleByDPI(0, 0);
      [*] = ;
      [*] = ;var w : Integer = GetViewerWidth;
      [*] = ;var h : Integer = GetViewerHeight;
      [*] = ;var artW : Integer = GetGUITextureWidth('mainmenu_art0');
      [*] = ;var a : Integer = 350; //MGraphics
      [*] = ;var xaperc : Float = 0.89;
      [*] = ;var xa : Integer = floor((xaperc*w)-dpiscale*a/2);
      [*] = ;if (w<xa+(a+60)*dpiscale) then
      [*] = ;xa := w-round((a+60)*dpiscale);
      [*] = ;
      [*] = ;var cMinYArt : Integer = round(902*dpiscale);
      [*] = ;//const cMinYLogo = 902+100+160;
      [*] = ;var cMinYLogo : Integer = round(902*dpiscale);
      [*] = ;const cMinB = 785; //MGraphics
      [*] = ;var b : Integer = floor(w-xa-a);
      [*] = ;if (b<cMinB) then
      [*] = ;xa := xa+b-cMinB;
      [*] = ;
      [*] = ;var yArt : Integer;
      [*] = ;var yLogo : Integer;
      [*] = ;if (h<cMinYArt) then
      [*] = ;yArt := (cMinYArt-h) div 2;
      [*] = ;
      [*] = ;if (h<cMinYLogo) then
      [*] = ;yLogo := (cMinYLogo-h) div 2;
      [*] = ;
      [*] = ;var cTextProfile : String = GetLocaleTableListItemByID('gui', 'menu.btn.profile');
      [*] = ;var cTextCampaign : String = GetLocaleTableListItemByID('gui', 'menu.btn.campaign');
      [*] = ;var cTextRandomMap : String = GetLocaleTableListItemByID('gui', 'menu.btn.randommap');
      [*] = ;var cTextSettings : String = GetLocaleTableListItemByID('gui', 'menu.btn.settings');
      [*] = ;var cTextSingleplayer : String = GetLocaleTableListItemByID('gui', 'menu.btn.singleplayer');
      [*] = ;var cTextMultiplayer : String = GetLocaleTableListItemByID('gui', 'menu.btn.multiplayer');
      [*] = ;var cTextLoadGame : String = GetLocaleTableListItemByID('gui', 'menu.btn.loadgame');
      [*] = ;var cTextLoadReplay : String = GetLocaleTableListItemByID('misc', 'loadgame.loadreplay');
      [*] = ;var cTextOptions : String = GetLocaleTableListItemByID('gui', 'menu.btn.options');
      [*] = ;var cTextEditor : String = GetLocaleTableListItemByID('gui', 'menu.btn.editor');
      [*] = ;var cTextExit : String = GetLocaleTableListItemByID('gui', 'menu.btn.exit');
      [*] = ;
      [*] = ;var elmParent : Integer = _ui_CreateCol(ui, elmname, 0, gc_halLeft, 0, 12/dpiscale, 0, 0, round(GetViewerHeight/dpiscale), bupdate);
      [*] = ;_gui_AbsScaleByDPI(elmParent);
      [*] = ;SetGUIElementPressState(elmParent, eventstate);
      [*] = ;var elmBlackMask : Integer = _gui_CreateImageActive('blmask', elmParent, gc_gui_material_black, gc_halLeft, gc_valTop, 0, 0, GetViewerWidth, GetViewerHeight, 0, '', '', bupdate);
      [*] = ;var nart : Integer = floor(random*gc_mod_arts_amount);//MGraphics 
      [*] = ;var mart : String = 'mainmenu_art'+IntToStr(nart);//MGraphics 
      [*] = ;var elmBackground : Integer = _gui_CreateImage('bcg', elmParent, mart, gc_halMiddle, gc_valMiddle, 0, yArt, 1920, 1080, 0, bupdate); //MGraphics
      [*] = ;var elmLeft : Integer = _ui_CreateCustomContainer(ui, 'col1', elmParent, gc_halParentLeft, gc_valParentTop, round(xa/dpiscale), 0, a, GetViewerHeight, bupdate);
      [*] = ;SetGUIElementUserBlend(GetGUIElementIndexByNameParent('debug', elmLeft), 0.75);
      [*] = ;var elmLeftRow : Integer = _ui_CreateRow(ui, 'row1', elmLeft, gc_valParentMiddle, 0, GetViewerHeight-20*2*0, bupdate);
      [*] = ;var elmLeftFrame : Integer = _ui_CreateFrame(ui, 'wnewgame', elmLeftRow, gc_halParentLeft, gc_valParentTop, 0, 0, 0, round(GetViewerHeight/dpiscale), ui.frame1.fborder, ' ', 0, bupdate);
      [*] = ;
      [*] = ;var ind : Integer;
      [*] = ;var cAddOffset : Integer = cBtnOffset-yLogo-99; //MGraphics end
      [*] = ;var cLogoBaseOffset : Integer = -yLogo+round(234/2);
      [*] = ;if (GetViewerHeight/dpiscale)<700 then
      [*] = ;cLogoBaseOffset := cLogoBaseOffset-90;//MGraphics end
      [*] = ;var cBaseOffset : Integer = cLogoBaseOffset+GetGUITextureHeight('logo_small')-30;
      [*] = ;var elmHnd : Integer;
      [*] = ;const cbtnmat = 'btn.large';
      [*] = ;elmHnd := ShowButton('bcampaign', elmHnd, elmLeftFrame, 'btn.green', cTextCampaign, cBaseOffset, cTagCampaign, gbool_gui_isfileexists_campaigns);
      [*] = ;elmHnd := ShowButton('bmultiplayer', elmHnd, elmLeftFrame, 'btn.green', cTextMultiplayer, cmargin2, cTagMultiplayer, IsEngine);
      [*] = ;elmHnd := ShowButton('brandommap', elmHnd, elmLeftFrame, 'btn.green', cTextRandomMap, cmargin2, cTagRandomMap, True);
      [*] = ;elmHnd := ShowButton('bsettings', elmHnd, elmLeftFrame, cbtnmat, cTextSettings, cmargin2, cTagSettings, True);
      [*] = ;elmHnd := ShowButton('bloadgame', elmHnd, elmLeftFrame, cbtnmat, cTextLoadGame, cmargin2, cTagLoadGame, True);
      [*] = ;elmHnd := ShowButton('bprofile', elmHnd, elmLeftFrame, 'btn.medium', cTextProfile, cmargin2, cTagProfile, True);
      [*] = ;elmHnd := ShowButton('bprofile', elmHnd, elmLeftFrame, 'btn.medium', cTextProfile, cmargin2, cTagProfile, True);
      [*] = ;elmHnd := ShowButton('bloadreplay', elmHnd, elmLeftFrame, 'btn.medium', cTextLoadReplay, cmargin2, cTagLoadReplay, True);
      [*] = ;elmHnd := ShowButton('beditor', elmHnd, elmLeftFrame, 'btn.medium', cTextEditor, cmargin2, cTagEditor, True);
      [*] = ;elmHnd := ShowButton('bexit', elmHnd, elmLeftFrame, 'btn.red', cTextExit, cmargin2, cTagExit, True);
      [*] = ;elmHnd := ShowButton('bexit', elmHnd, elmLeftFrame, 'btn.red', cTextExit, cmargin2, cTagExit, True);
      [*] = ;//MGraphics end
      [*] = ;
      [*] = ;var elmLogo : Integer = _gui_CreateImage('', elmLeftRow, 'logo_small', gc_halParentMiddle, gc_valParentTop, 0, cLogoBaseOffset, 656, 218, 0, bupdate);
      [*] = ;
      [*] = ;var color : TColor; _gui_ConvertHexToTColor('ffffff', color);
      [*] = ;var cTextVersion : String = GetLocaleTableListItemByID('misc', 'version');
      [*] = ;cTextVersion := StrReplace(cTextVersion, '%ver%', GetBuildVersion);
      [*] = ;cTextVersion := StrReplace(cTextVersion, '%dataver%', '.'+IntToStr(gDataVersion));
      [*] = ;cTextVersion := 'Cossacks 3 v.'+cTextVersion+'.'+IntToStr(gSVNVersion);
      [*] = ;if (gProfile.lastknowndlcs<>0) then
      [*] = ;begin
      [*] = ;   var dlctext : String = ' (';
      [*] = ;   if ((gProfile.lastknowndlcs and gc_lastknowndlc_earlybird<>0))
      [*] = ;   or ((gProfile.purchaseunixtime>0) and (gProfile.purchaseunixtime<=gc_unixtime_earlybirdend)) then
      [*] = ;   dlctext := dlctext+'Early bird';
      [*] = ;   if (gProfile.lastknowndlcs and gc_lastknowndlc_deluxe<>0) then
      [*] = ;   begin
      [*] = ;      if (dlctext<>' (') then
      [*] = ;      dlctext := dlctext+' + ';
      [*] = ;      dlctext := dlctext+'deluxe';
      [*] = ;   end;
      [*] = ;   dlctext := dlctext+')';
      [*] = ;   cTextVersion := cTextVersion+dlctext;
      [*] = ;end;
      [*] = ;_gui_CreateText('ver', elmLeftFrame, cTextVersion, gc_halParentRightWidth, gc_valParentBottomHeight, -4, -GetGUIElementFontHeight(gUIConst.font[gc_font_serif_12]), GetGUIElementWidth(elmLeftFrame), 0, gc_halRight, gc_valMiddle, gc_font_serif_10, color, True);
      [*] = ;var modscount : Integer = ModLibraryGetCount;
      [*] = ;if modscount>0 then
      [*] = ;begin
      [*] = ;   var cTextMods : String = GetLocaleTableListItemByID('new', 'mods.modslist');
      [*] = ;   var libind, enum : Integer;
      [*] = ;   var tag, dir, last, tit, ownid, desc, tags, url, note: string;
      [*] = ;   var numf, vis: integer;
      [*] = ;   var dis, acc, ban, root: boolean;
      [*] = ;   for libind:=0 to modscount-1 do
      [*] = ;   begin
      [*] = ;      ModLibraryGetData(libind, tag, dir, last, tit, ownid, desc, tags, url, note, numf, vis, dis, acc, ban, root);
      [*] = ;      if (not dis) then
      [*] = ;   begin
      [*] = ;      var modname : String;
      [*] = ;         if tag='0' then
      [*] = ;         begin
      [*] = ;            if last<>'' then
      [*] = ;            modname := '*'+last
      [*] = ;            else
      [*] = ;            modname := '*'+dir;
      [*] = ;         end
      [*] = ;         else
      [*] = ;         if tit<>'' then
      [*] = ;         modname := tit
      [*] = ;         else
      [*] = ;         if last<>'' then
      [*] = ;         modname := '*'+last
      [*] = ;         else
      [*] = ;         modname := GetLocaleTableListItemByID('new', 'mods.unknown');
      [*] = ;
      [*] = ;         cTextMods := cTextMods+gc_gui_breakline+modname;
      [*] = ;         enum := enum+1;
      [*] = ;      end;
      [*] = ;   end;
      [*] = ;   var dpiscale : Float = _gui_GetAbsScaleByDPI(0, 0);
      [*] = ;   cTextMods := GetGUIWrappedTextByFont(gUIConst.font[gc_font_serif_10], cTextMods, round(GetViewerWidth/(dpiscale*3)));
      [*] = ;   _misc_CalcCheckSum;
      [*] = ;   cTextMods := cTextMods+gc_gui_breakline+'('+gstring_checksum+')';
      [*] = ;   var elmHnd : Integer = _gui_CreateText('mod', elmLeftFrame, cTextMods, gc_halLeft, gc_valParentBottomHeight, 10, -GetGUIElementFontHeight(gUIConst.font[gc_font_serif_12]), 0, 0, gc_halLeft, gc_valTop, gc_font_serif_10, color, True);
      [*] = ;
      [*] = ;   gbool_modsactive := enum>0;
      [*] = ;   SetGUIElementVisible(elmHnd, gbool_modsactive);
      [*] = ;end
      [*] = ;else
      [*] = ;begin
      [*] = ;   gbool_modsactive := False;
      [*] = ;   gstring_checksumlong := '';
      [*] = ;   gstring_checksum := '';
      [*] = ;   end;
      [*] = ;dbgstatename := 'ShowMainMenu';
   struct.end
section.end

